#ifndef __LASH_H
#define __LASH_H

#include "util.h"

// ----------------------------------------------------------------------------

// !!! define exactly one hash type
//#define LASH_CONFIG_SIZE_160                  /* 160-bit output version    */
//#define LASH_CONFIG_SIZE_256                  /* 256-bit output version    */
//#define LASH_CONFIG_SIZE_384                  /* 384-bit output version    */
  #define LASH_CONFIG_SIZE_512                  /* 512-bit output version    */

// !!! define exactly one compression type
//#define LASH_CONFIG_COMP_BYTE                 /* byte based compression    */
  #define LASH_CONFIG_COMP_WORD                 /* word based compression    */
//#define LASH_CONFIG_COMP_SIMD                 /* simd based compression    */

// !!! define exactly one computation type
  #define LASH_CONFIG_MATRIX_ALL                /* everything precomputed    */
//#define LASH_CONFIG_MATRIX_ROW                /* one row    precomputed    */
//#define LASH_CONFIG_MATRIX_COL                /* one col    precomputed    */

// ----------------------------------------------------------------------------

void lash_init();
void lash_fini();

int  lash_sizeof_dig();     // bytes in digest
int  lash_sizeof_blk();     // bytes in block

void lash_proc( byte*  d,   // digest
                byte*  v,   // message
                uint64 l ); // length (in bytes)

#endif
