#ifndef __LASH_X86_SIMD_ROW_H
#define __LASH_X86_SIMD_ROW_H

#if   defined( LASH_CONFIG_SIZE_160 )
// {{{ LASH_160
static inline void comp( byte* r, byte* s )
{
  __m128i sse0;
  __m128i sse1;
  __m128i sse2;
//__m128i sse3;
//__m128i sse4;
//__m128i sse5;
//__m128i sse6;
  __m128i sse7;

  byte* h;

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 0 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 0 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 1 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 1 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 2 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 2 );
  sse2 = _mm_xor_si128( sse2, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 0 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 1 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 2 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( r ) + 0, sse0 );
  _mm_storeu_si128( ( __m128i* )( r ) + 1, sse1 );
  _mm_storeu_si128( ( __m128i* )( r ) + 2, sse2 );
}
// }}}
#elif defined( LASH_CONFIG_SIZE_256 )
// {{{ LASH_256
static inline void comp( byte* r, byte* s )
{
  __m128i sse0;
  __m128i sse1;
  __m128i sse2;
  __m128i sse3;
//__m128i sse4;
//__m128i sse5;
//__m128i sse6;
  __m128i sse7;

  byte* h;

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 0 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 0 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 1 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 1 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 2 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 2 );
  sse2 = _mm_xor_si128( sse2, sse7 );
  sse3 = _mm_loadu_si128( ( __m128i* )( r ) + 3 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 3 );
  sse3 = _mm_xor_si128( sse3, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 0 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 1 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 2 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 3 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse3) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( r ) + 0, sse0 );
  _mm_storeu_si128( ( __m128i* )( r ) + 1, sse1 );
  _mm_storeu_si128( ( __m128i* )( r ) + 2, sse2 );
  _mm_storeu_si128( ( __m128i* )( r ) + 3, sse3 );
}
// }}}
#elif defined( LASH_CONFIG_SIZE_384 )
// {{{ LASH_384
static inline void comp( byte* r, byte* s )
{
  __m128i sse0;
  __m128i sse1;
  __m128i sse2;
//__m128i sse3;
//__m128i sse4;
//__m128i sse5;
//__m128i sse6;
  __m128i sse7;

  byte  t[ M ];
  byte* h     ;

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 0 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 0 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 1 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 1 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 2 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 2 );
  sse2 = _mm_xor_si128( sse2, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 0 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 1 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 2 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( t ) + 0, sse0 );
  _mm_storeu_si128( ( __m128i* )( t ) + 1, sse1 );
  _mm_storeu_si128( ( __m128i* )( t ) + 2, sse2 );

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 3 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 3 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 4 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 4 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 5 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 5 );
  sse2 = _mm_xor_si128( sse2, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 3 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 4 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 5 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( t ) + 3, sse0 );
  _mm_storeu_si128( ( __m128i* )( t ) + 4, sse1 );
  _mm_storeu_si128( ( __m128i* )( t ) + 5, sse2 );

  memcpy( r, t, m );
}
// }}}
#elif defined( LASH_CONFIG_SIZE_512 )
// {{{ LASH_512
static inline void comp( byte* r, byte* s )
{
  __m128i sse0;
  __m128i sse1;
  __m128i sse2;
  __m128i sse3;
//__m128i sse4;
//__m128i sse5;
//__m128i sse6;
  __m128i sse7;

  byte  t[ M ];
  byte* h     ;

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 0 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 0 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 1 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 1 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 2 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 2 );
  sse2 = _mm_xor_si128( sse2, sse7 );
  sse3 = _mm_loadu_si128( ( __m128i* )( r ) + 3 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 3 );
  sse3 = _mm_xor_si128( sse3, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 0 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 1 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 2 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 3 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse3) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( t ) + 0, sse0 );
  _mm_storeu_si128( ( __m128i* )( t ) + 1, sse1 );
  _mm_storeu_si128( ( __m128i* )( t ) + 2, sse2 );
  _mm_storeu_si128( ( __m128i* )( t ) + 3, sse3 );

  sse0 = _mm_loadu_si128( ( __m128i* )( r ) + 4 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 4 );
  sse0 = _mm_xor_si128( sse0, sse7 );
  sse1 = _mm_loadu_si128( ( __m128i* )( r ) + 5 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 5 );
  sse1 = _mm_xor_si128( sse1, sse7 );
  sse2 = _mm_loadu_si128( ( __m128i* )( r ) + 6 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 6 );
  sse2 = _mm_xor_si128( sse2, sse7 );
  sse3 = _mm_loadu_si128( ( __m128i* )( r ) + 7 );
  sse7 = _mm_loadu_si128( ( __m128i* )( s ) + 7 );
  sse3 = _mm_xor_si128( sse3, sse7 );

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 4 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse0) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 5 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse1) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 6 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse2) : "x" (sse7) );
        sse7 = _mm_loadu_si128( ( __m128i* )( h ) + 7 );
        __asm__ __volatile__( "paddb %1, %0" : "+x" (sse3) : "x" (sse7) );
      }

      h -= 1;
    }
  }  

  _mm_storeu_si128( ( __m128i* )( t ) + 4, sse0 );
  _mm_storeu_si128( ( __m128i* )( t ) + 5, sse1 );
  _mm_storeu_si128( ( __m128i* )( t ) + 6, sse2 );
  _mm_storeu_si128( ( __m128i* )( t ) + 7, sse3 );

  memcpy( r, t, m );
}
// }}}
#endif

#endif


