#ifndef __LASH_X86_WORD_ROW_H
#define __LASH_X86_WORD_ROW_H

static inline void comp( byte* r, byte* s )
{
  byte  t[ M ];
  byte* h     ;

  for( int i = 0; i < ( m >> 2 ); i++ )
  { 
    uint32* _t = ( uint32* )( t );
    uint32* _r = ( uint32* )( r );
    uint32* _s = ( uint32* )( s );

    _t[ i ] = _r[ i ] ^ _s[ i ];
  }

  h = H + n;

  for( int i = 0; i < ( m << 1 ); i++ )
  {
    byte b;

    if( i < m )
      b = r[ i - 0 ];
    else
      b = s[ i - m ];

    for( int j = 7; j >= 0; j-- ) // !!!
    {
      if( ( b >> j ) & 1 )
      {
        uint32* _t = ( uint32* )( t );
        uint32* _h = ( uint32* )( h );

        #if defined( LASH_CONFIG_SIZE_PART0 )
        _t[  0 ] = padd32( _t[  0 ], _h[  0 ] );
        _t[  1 ] = padd32( _t[  1 ], _h[  1 ] );
        _t[  2 ] = padd32( _t[  2 ], _h[  2 ] );
        _t[  3 ] = padd32( _t[  3 ], _h[  3 ] );
        _t[  4 ] = padd32( _t[  4 ], _h[  4 ] );
        _t[  5 ] = padd32( _t[  5 ], _h[  5 ] );
        _t[  6 ] = padd32( _t[  6 ], _h[  6 ] );
        _t[  7 ] = padd32( _t[  7 ], _h[  7 ] );
        _t[  8 ] = padd32( _t[  8 ], _h[  8 ] );
        _t[  9 ] = padd32( _t[  9 ], _h[  9 ] );
        #endif
        #if defined( LASH_CONFIG_SIZE_PART1 )
        _t[ 10 ] = padd32( _t[ 10 ], _h[ 10 ] );
        _t[ 11 ] = padd32( _t[ 11 ], _h[ 11 ] );
        _t[ 12 ] = padd32( _t[ 12 ], _h[ 12 ] );
        _t[ 13 ] = padd32( _t[ 13 ], _h[ 13 ] );
        _t[ 14 ] = padd32( _t[ 14 ], _h[ 14 ] );
        _t[ 15 ] = padd32( _t[ 15 ], _h[ 15 ] );
        #endif
        #if defined( LASH_CONFIG_SIZE_PART2 )
        _t[ 16 ] = padd32( _t[ 16 ], _h[ 16 ] );
        _t[ 17 ] = padd32( _t[ 17 ], _h[ 17 ] );
        _t[ 18 ] = padd32( _t[ 18 ], _h[ 18 ] );
        _t[ 19 ] = padd32( _t[ 19 ], _h[ 19 ] );
        _t[ 20 ] = padd32( _t[ 20 ], _h[ 20 ] );
        _t[ 21 ] = padd32( _t[ 21 ], _h[ 21 ] );
        _t[ 22 ] = padd32( _t[ 22 ], _h[ 22 ] );
        _t[ 23 ] = padd32( _t[ 23 ], _h[ 23 ] );
        #endif
        #if defined( LASH_CONFIG_SIZE_PART3 )
        _t[ 24 ] = padd32( _t[ 24 ], _h[ 24 ] );
        _t[ 25 ] = padd32( _t[ 25 ], _h[ 25 ] );
        _t[ 26 ] = padd32( _t[ 26 ], _h[ 26 ] );
        _t[ 27 ] = padd32( _t[ 27 ], _h[ 27 ] );
        _t[ 28 ] = padd32( _t[ 28 ], _h[ 28 ] );
        _t[ 29 ] = padd32( _t[ 29 ], _h[ 29 ] );
        _t[ 30 ] = padd32( _t[ 30 ], _h[ 30 ] );
        _t[ 31 ] = padd32( _t[ 31 ], _h[ 31 ] );
        #endif
      }

      h -= 1;
    }
  }  

  memcpy( r, t, m );
}

#endif

