/*
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ''AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

/* This program 2001 by Sam Trenholme.  This is under the same license as
   the rest of the tiger code */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

main(int argc, char **argv) {
    int desc, readed, counter;
    char *buf;
    struct stat info;
    u_int32_t res[7];

    if(argc != 2) {
        printf("Usage: tiger {filename}\n");
	exit(1);
	}
 
    if((desc = open(argv[1],O_RDONLY)) < 0) {
        perror("Could not open file");
	exit(2);
	}

    if(fstat(desc,&info) < 0) {
        perror("Could not stat file");
	exit(3);
	}

    if((buf = (char *)malloc(info.st_size + 1)) == NULL) {
        perror("Could not allocate memory");
	exit(4);
	}
 
    if(read(desc,buf,info.st_size) != info.st_size) {
        perror("Problem reading file");
	exit(5);
	}

    tiger(buf,info.st_size,res);
    printf("Tiger digest: ");
    for(counter = 0; counter < 6; counter += 2)
        printf("%08x%08x",res[counter + 1],res[counter]);
    printf("\n");

    }

